00100 ;Tchron/ASM - 08/17/82 - Copyright 1981 by Roy Soltoff
00110 ;*=*=*
00120 ; TCHRON mods to LDOS Version 5.1.3 (Model I)
00130 ;*=*=*
00140 TIME$   EQU     4041H           ;Time string
00150 DATE$   EQU     4044H           ;Date string
00160 DCTFLD@ EQU     47A5H           ;Mask & multiply by 10
00170 LOW$    EQU     4047H           ;Extended date
00180 ;
00190 ;*=*=*
00200 ; Routines for time reading
00210 ;*=*=*
00220         ORG     45C1H           ;Normal timer routine
00230 ;
00240         DW      TIMER           ;Set timer TCB
00250 GETARG  IN      A,(C)           ;Get high byte
00260         DEC     C               ;Bump port
00270         CALL    DCTFLD@+1       ;Strip, *10 -> L
00280         IN      A,(C)           ;Get low byte
00290         DEC     C               ;Bump port
00300         AND     0FH             ;Strip
00310         ADD     A,L             ;Add in high * 10
00320         LD      (DE),A          ;Stuff value
00330         DEC     DE              ;Bump pointer
00340         RET
00350 TIMER   LD      DE,TIME$+2      ;Point to end of string
00360         LD      BC,3<8!0B5H     ;Set loop cnt & port ***0C5H***
00370 LOOP    CALL    GETARG
00380         DJNZ    LOOP
00390 ;*=*=*
00400 ; Now fall through to RET instruction at TIMHK$
00410 ; User must NOT use SYSTEM (UPDATE)...
00420 ;*=*=*
00430 ;*=*=*
00440 ; Interface to system initialization for DATE
00450 ;*=*=*
00460         ORG     4E9EH           ;Address of DATE query
00470 PACKIT  EQU     4EE8H           ;Addr of packing routine
00480 ;
00490         LD      HL,DATE$+2      ;Point to end of parm
00500         LD      BC,1<8!0BAH     ;Set mask & port ***0CAH***
00510         CALL    GETVAL          ;Get month
00520         LD      B,3             ;Set mask for day
00530         CALL    GETVAL          ;Get day value
00540         LD      BC,0FH<8!0BCH   ;Set year mask & port ***0CCH***
00550         CALL    GETVAL          ;Get year
00560         EX      DE,HL           ;Point DE to date$-1
00570         IN      A,(0BBH)        ;Ck on leap year ***0CBH***
00580         AND     3
00590         LD      DE,DATE$+1      ;Set for pack routine
00600         LD      HL,LOW$+1
00610         JR      NZ,PACKIT
00620         SET     7,(HL)          ;Set leap year bit
00630         JR      PACKIT          ;Go pack it in
00640 ;*=*=*
00650 ; Routine to input date values
00660 ;*=*=*
00670 GETVAL  IN      A,(C)           ;Get high
00680         DEC     C               ;Reduce port
00690         AND     B               ;Mask high
00700         RLCA                    ;High * 10
00710         LD      D,A
00720         RLCA
00730         RLCA
00740         ADD     A,D
00750         LD      D,A             ;Save high * 10
00760         IN      A,(C)           ;Get low
00770         DEC     C
00780         AND     0FH             ;Mask the bad stuff
00790         ADD     A,D             ;Add in high
00800         LD      (HL),A          ;Stuff in parm
00810         DEC     HL
00820         RET
00830         END     4E00H
